#ifndef ASSOCH
#define ASSOCH 

/* Assoc.hxx -- declarations for key-value association

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "LookupKey.hxx"

extern Class class_Assoc;

class Assoc: public LookupKey {
	obid avalue;
public:
	Assoc(const Object& newKey =*nil, const Object& newValue =*nil);
	Assoc(fileDescTy&,Assoc&);
	Assoc(istream&,Assoc&);
	virtual void deepenShallowCopy();
	virtual const Class* isA();
	virtual void printOn(ostream& strm);
	virtual void storer(fileDescTy&);
	virtual void storer(ostream&);
	virtual obid value();
	virtual obid value(const Object& newvalue);
};

#endif
