# 1 "Assoc.cxx" 




































# 1 "./Assoc.hxx" 1






















# 1 "./LookupKey.hxx" 1






















# 1 "./Object.hxx" 1














































































# 1 "/usr/include/stdio.h" 1





extern	struct	_iobuf {
	int	_cnt;
	unsigned char *_ptr;
	unsigned char *_base;
	int	_bufsiz;
	short	_flag;
	char	_file;		
} _iob[];



















# 36 "/usr/include/stdio.h" 

















extern struct _iobuf	*fopen();
extern struct _iobuf	*fdopen();
extern struct _iobuf	*freopen();
extern struct _iobuf	*popen();
extern struct _iobuf	*tmpfile();
extern long	ftell();
extern char	*fgets();
extern char	*gets();
# 63 "/usr/include/stdio.h" 

extern char	*ctermid();
extern char	*cuserid();
extern char	*tempnam();
extern char	*tmpnam();






# 80 "./Object.hxx" 2
# 1 "./errors.hxx" 1













const int MAX_MSG_ARG =	8;      
const int MAX_FACILITIES = 32;  
const int SYS_LAST_ERROR = 34;	


enum severity_level { SUCCESS = 0,
		      INFORMATION = -1,
		      INFO = -1,
		      WARNING = -2,
		      ERROR = -3,
		      FATAL = -4,
		      DEFAULT = 1 };


const int FAC_SHIFT =    12;	    // right shift count to get facility code
const int OFFSET_MASK =  0xfff;     // mask for offset portion of error 
const int FAC_MASK =     0xfff000;  // mask for facility portion 

inline int FACILITY_CODE(int ER) { return ((ER&FAC_MASK)>>FAC_SHIFT); }
inline int OFFSET_INDEX(int ER)  { return (ER&OFFSET_MASK); }

class ErrSpecs {
public:
	int severity;		
	char* args;		
	char* text;		
	};


class ErrFac {
public:
	char* longname;		
	ErrSpecs* errlist;	
	int last;		
	};

# 82 "./Object.hxx" 2

const char YES = 1;
const char NO = 0;
typedef int fileDescTy;

overload ABS;
inline int	ABS(int x)	{ return x >= 0 ? x : -x; }
inline long	ABS(long x)	{ return x >= 0 ? x : -x; }
inline float	ABS(float x)	{ return x >= 0 ? x : -x; }
//inline double	ABS(double x)	{ return x >= 0 ? x : -x; }
overload MAX;
inline int	MAX(int a,int b)	{ return a >= b ? a : b; }
inline long	MAX(long a,long b)	{ return a >= b ? a : b; }
inline float	MAX(float a,float b)	{ return a >= b ? a : b; }
//inline double	MAX(double a,double b)	{ return a >= b ? a : b; }
inline unsigned int	MAX(unsigned int a, unsigned int b)	{ return a >= b ? a : b; }
inline unsigned long	MAX(unsigned long a, unsigned long b)	{ return a >= b ? a : b; }
overload MIN;
inline int	MIN(int a,int b)	{ return a <= b ? a : b; }
inline long	MIN(long a,long b)	{ return a <= b ? a : b; }
inline float	MIN(float a,float b)	{ return a <= b ? a : b; }
//inline double	MIN(double a,double b)	{ return a <= b ? a : b; }
inline unsigned int	MIN(unsigned int a, unsigned int b)	{ return a <= b ? a : b; }
inline unsigned long	MIN(unsigned long a, unsigned long b)	{ return a <= b ? a : b; }



















class Object;
typedef Object* obid;
class Class;
class IdentDict;
class OrderedCltn;

class Object {
public:
	Object() {}
	void	assertArgClass(const Object& ob, const Class& expect, const char* fname);	// validate argument class
	void	assertArgSpecies(const Object& ob, const Class& expect, const char* fname);	// validate argument species
	const	Class* baseClass();				// return pointer to base class descriptor
	const	char* className();				// return class name 
	unsigned classVersion();				// return class version 
	void	derivedClassResponsibility(const char*);	// unimplemented virtual function 
	void	invalidArgClass(const Object& ob, const Class& expect, const char* fname);	// invalid object class error
	void	invalidArgSpecies(const Object& ob, const Class& expect, const char* fname);	// invalid object species error
	char	isKindOf(const Class&);			// YES if MemberOf class or a superclass 
	char	isMemberOf(const Class& clid)		{ return isA()==&clid; }
	char	isSame(const Object& ob)		{ return this==&ob; }
	char	isSpecies(const Class& clid)		{ return species()==&clid; }
	void	shouldNotImplement(const char*);	// class cannot impl this function 
	void	storeOn(fileDescTy&);			// store object in binary on file
	void	storeOn(ostream&);			// store object on stream 
	virtual obid addDependent(const Object&);	// add dependent object 
	virtual unsigned capacity();			// subclass capacity 
	virtual void changed();				// notify dependents of change 
	virtual void changed(const Object&);		// notify dependents of change 
	virtual int compare(const Object&);		// compare objects 
	virtual obid copy();				// copy defaulted as deepCopy 
	virtual obid deepCopy();			// copy with distinct instance variables 
	virtual void deepenShallowCopy();		// convert shallow copy to deep copy 
	virtual OrderedCltn& dependents();		// return list of dependent objects 
	virtual void destroyer();			// destroy object
	virtual unsigned hash();			// calculate object hash 
	virtual const Class* isA();			// return class descriptor address 
	virtual char isEqual(const Object&);		// equality test 
	virtual void scanFrom(istream& strm);		// parse object from stream 
	virtual void printOn(ostream& strm);		// print object on stream 
	virtual void release();				// remove all dependent objects 
	virtual obid removeDependent(const Object&);	// remove dependent object 
	virtual obid shallowCopy();			// copy with shared instance variables 
	virtual unsigned size();			// # of objects in array/container subclass
	virtual const Class* species();			// return species class descriptor address 
	virtual void storer(fileDescTy&);		// store this class in binary on file
	virtual void storer(ostream&);			// store this class on stream 
	virtual void update(const Object&, const Object&);	// object change notification 
	virtual void clearForReadFrom(); 		// Used to prevent memory leaks - DON'T CALL THIS FUNCTION
};

typedef void (*initorTy)(const Class&);

class Class : public Object {	// class descriptor object 
	const Class* superClass;	// pointer to this class's base class (superclass) object 
	const Class* nextClass;		// link for list of all Class objects 
	const char* class_name;		// class name 
	unsigned class_version;		// class version number 
	unsigned def_version;		
	unsigned inst_size;		// sizeof instance variables 
	void (*inst_reader)(istream&,Object&);		// object reader function 
	void (*inst_binreader)(fileDescTy&,Object&); 	// binary reader function
	initorTy class_initor2;		// phase 2 class initor
	unsigned class_number;		// class number, used by storeOn()
	friend void Object::storeOn(fileDescTy&);	
	friend void Object::storeOn(ostream&);
	friend void Object::storer(fileDescTy&);
	friend void Object::storer(ostream&);
	friend void OOPS__classInit();
public:
	Class(const Class& super, const char* name,
		unsigned version, unsigned size,
		void (*reader)(istream&,Object&), 
		void (*binreader)(fileDescTy&,Object&), 
		initorTy initor1 =0, initorTy initor2 =0);
//	Class(fileDescTy&,Class&) {}	// cfront 1.2.1 bug
//	Class(istream&,Class&) {}	// cfront 1.2.1 bug
	const Class* baseClass()		{ return superClass; }
	const char* className()			{ return class_name; }
	unsigned classNumber()			{ return class_number; }
	unsigned classNumber(unsigned n)	{ return class_number = n; }
	unsigned classVersion()			{ return class_version; }
	void reader(istream& strm, Object& where)	{ (*inst_reader)(strm,where); }
	void reader(fileDescTy& fd, Object& where)	{ (*inst_binreader)(fd,where); }
	virtual int compare(const Object&);	// compare class names 
	virtual obid deepCopy();		// shouldNotImplement 
	virtual unsigned hash();
	virtual const Class* isA();
	virtual char isEqual(const Object& ob);
	virtual void printOn(ostream& strm);
	virtual obid shallowCopy();		// shouldNotImplement 
	virtual unsigned size();
	virtual void storer(ostream&);
	virtual void storer(fileDescTy&);
};

extern Class* allClasses;	// header of list of all Classes 
extern Class class_Class;	// Class of Classes 
extern Class class_Object;
extern const obid const nil;	// pointer to sole instance of nil object 

inline const Class* Object::baseClass()	{ return isA()->baseClass(); }

 static const char* Object::className()	{ return isA()->className(); }	// static due to CC bug

inline unsigned Object::classVersion()	{ return isA()->classVersion(); }
		
inline istream& operator>>(istream& strm, Object& ob)
{
	ob.scanFrom(strm);
	return strm;
}

inline ostream& operator<<(ostream& strm, const Object& ob)
{
	ob.printOn(strm);
	return strm;
}

overload readFrom;
extern obid readFrom(istream&, const char* expectedClass ="", Object& where =*(Object*)0);	// read object from stream 
extern obid readFrom(fileDescTy&, const char* expectedClass ="", Object& where =*(Object*)0);	// read object in binary from file

extern char OOPS__Initialized;
inline char OOPSInitialized() {	return OOPS__Initialized; }

extern void OOPSIoErrCleanup();

extern void setOOPSerror(int error, int sev ...);			// decl an OOPS error condition

extern void invalidArgClass(const Object& ob, const Class& expect, const char* fname);	// invalid argument class error
extern void invalidArgSpecies(const Object& ob, const Class& expect, const char* fname);// invalid argument species error
extern void invalidClass(const Object& ob, const Class& expect);			// invalid object class error
extern void invalidSpecies(const Object& ob, const Class& expect);			// invalid object species error

inline void assertArgClass(const Object& ob, const Class& expect, const char* fname)
{
	if (!((ob).isKindOf(expect))) ::invalidArgClass(ob,expect,fname);
}

inline void assertArgSpecies(const Object& ob, const Class& expect, const char* fname)
{
	if (!((ob).isSpecies(expect))) ::invalidArgSpecies(ob,expect,fname);
}

inline void Object::assertArgClass(const Object& ob, const Class& expect, const char* fname)
{
	if (!((ob).isKindOf(expect))) this->invalidArgClass(ob,expect,fname);
}

inline void Object::assertArgSpecies(const Object& ob, const Class& expect, const char* fname)
{
	if (!((ob).isSpecies(expect))) this->invalidArgSpecies(ob,expect,fname);
}

inline void assertClass(const Object& ob, const Class& expect)
{
	if (!((ob).isKindOf(expect))) ::invalidClass(ob,expect);
}

inline void assertSpecies(const Object& ob, const Class& expect)
{
	if (!((ob).isSpecies(expect))) ::invalidSpecies(ob,expect);
}


# 24 "./LookupKey.hxx" 2

extern Class class_LookupKey;

class LookupKey: public Object {
	obid akey;
public:
	LookupKey(const Object& newKey =*nil);
	LookupKey(fileDescTy&,LookupKey&);
	LookupKey(istream&,LookupKey&);
	virtual int compare(const Object&);
	virtual void deepenShallowCopy();
	virtual unsigned hash();
	virtual const Class* isA();
	virtual char isEqual(const Object&);
	virtual obid key();
	virtual obid key(const Object& newkey);
	virtual void printOn(ostream& strm);
	virtual void storer(fileDescTy&);
	virtual void storer(ostream&);
	virtual obid value();
	virtual obid value(const Object& newvalue);
};


# 24 "./Assoc.hxx" 2

extern Class class_Assoc;

class Assoc: public LookupKey {
	obid avalue;
public:
	Assoc(const Object& newKey =*nil, const Object& newValue =*nil);
	Assoc(fileDescTy&,Assoc&);
	Assoc(istream&,Assoc&);
	virtual void deepenShallowCopy();
	virtual const Class* isA();
	virtual void printOn(ostream& strm);
	virtual void storer(fileDescTy&);
	virtual void storer(ostream&);
	virtual obid value();
	virtual obid value(const Object& newvalue);
};


# 38 "Assoc.cxx" 2



overload Assoc_reader; static void Assoc_reader(istream& strm, Object& where) { new Assoc(strm,*(Assoc*)&where); }static void Assoc_reader(fileDescTy& fd, Object& where) { new Assoc(fd,*(Assoc*)&where); }Class class_Assoc = Class( class_LookupKey, "Assoc", 1, sizeof(Assoc), Assoc_reader, Assoc_reader, 0, 0 ); const Class* Assoc::isA() { return &class_Assoc; };

Assoc::Assoc(const Object& newKey, const Object& newValue) : (newKey)
{
	avalue = &newValue;
}

obid Assoc::value()	{ return avalue; }

obid Assoc::value(const Object& newvalue)
{
	obid temp = avalue;
	avalue = &newvalue;
	return temp;
}

void Assoc::deepenShallowCopy()
{
	LookupKey::deepenShallowCopy();
	avalue = avalue->deepCopy();
}

void Assoc::printOn(ostream& strm)
{
	strm << className() << "("; LookupKey::printOn(strm);
	strm << "="; avalue->printOn(strm); strm << ")";
}

Assoc::Assoc(istream& strm, Assoc& where) : (strm,where)
{
	this = &where;
	avalue = readFrom(strm);
}

void Assoc::storer(ostream& strm)
{
	LookupKey::storer(strm);
	avalue->storeOn(strm);
}

Assoc::Assoc(fileDescTy& fd, Assoc& where) : (fd,where)
{
	this = &where;
	avalue = readFrom(fd);
}

void Assoc::storer(fileDescTy& fd) 
{
	LookupKey::storer(fd);
	avalue->storeOn(fd);
}
