#ifndef ASSOCINTH
#define ASSOCINTH 

/* AssocInt.hxx -- declarations for key-Integer association

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "LookupKey.hxx"
#include "Integer.hxx"

extern Class class_AssocInt;

class AssocInt: public LookupKey {
	Integer avalue;
public:
	AssocInt(const Object& newKey =*nil, int newValue =0);
	AssocInt(fileDescTy&,AssocInt&);
	AssocInt(istream&,AssocInt&);
	virtual void deepenShallowCopy();
	virtual const Class* isA();
	virtual void printOn(ostream& strm);
	virtual void storer(fileDescTy&);
	virtual void storer(ostream&);
	virtual obid value();
	virtual obid value(const Object& newValue);
};

#endif
