#ifndef IDENTDICTH
#define IDENTDICTH 

/* IdentDict.hxx -- declarations for Identity Dictionary

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "Dictionary.hxx"

extern Class class_IdentDict;

class LookupKey;
class OrderedCltn;

class IdentDict: public Dictionary {
	virtual int findIndexOf(const Object&);
public:
	IdentDict(UNSIGNED size =CLTN_DEFAULT_CAPACITY);
	IdentDict(const IdentDict&);
	IdentDict(fileDescTy&,IdentDict&);
	IdentDict(istream&,IdentDict&);
	void operator=(const IdentDict&);
	virtual LookupKey& assocAt(const Object& key);
	virtual obid atKey(const Object& key);
	virtual obid atKey(const Object& key, const Object& newValue);
	virtual bool includesKey(const Object& key);
	virtual const Class* isA();
};

#endif
