#ifndef RANDOMH
#define RANDOMH 

/* Random.hxx -- declarations for pseudo-random number generator

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "Object.hxx"

extern Class class_Random;

class Random: public Object {
	long	randx;
public:
	Random();
	Random(long seed)		{ randx = seed; }
	Random(fileDescTy&,Random&);
	Random(istream&,Random&);
	float next();
	virtual obid	copy();			// { return shallowCopy(); }
	virtual void	deepenShallowCopy();	// {}
	virtual const Class* isA();
	virtual void printOn(ostream& strm);
	virtual void storer(fileDescTy&);
	virtual void storer(ostream&);
};

#endif
