#ifndef SEQCLTNH
#define SEQCLTNH

/* SeqCltn.hxx -- declarations for abstract sequential collections

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "Collection.hxx"

extern Class class_SeqCltn;

class SeqCltn: public Collection {
public:
	SeqCltn() {}
	SeqCltn(fileDescTy&,SeqCltn&) {}
	SeqCltn(istream&,SeqCltn&) {}
	virtual obid& at(int i);
	virtual void atAllPut(const Object& ob);
	virtual void deepenShallowCopy();
	virtual obid doNext(DoCltnPos&);
	virtual obid first();
 	virtual const Class* isA();
	virtual int indexOf(const Object& ob);
	virtual int indexOfSubCollection(const SeqCltn& cltn, int start=0);
	virtual obid last();
	virtual void replaceFrom(int start, int stop, const SeqCltn& replacement, int startAt =0);
};

#endif
